from ctypes import *
import usb._objfinalizer as _objfinalizer
import usb.libloader
from _typeshed import Incomplete

LIBUSB_SUCCESS: int
LIBUSB_ERROR_IO: int
LIBUSB_ERROR_INVALID_PARAM: int
LIBUSB_ERROR_ACCESS: int
LIBUSB_ERROR_NO_DEVICE: int
LIBUSB_ERROR_NOT_FOUND: int
LIBUSB_ERROR_BUSY: int
LIBUSB_ERROR_TIMEOUT: int
LIBUSB_ERROR_OVERFLOW: int
LIBUSB_ERROR_PIPE: int
LIBUSB_ERROR_INTERRUPTED: int
LIBUSB_ERROR_NO_MEM: int
LIBUSB_ERROR_NOT_SUPPORTED: int
LIBUSB_ERROR_OTHER: int
LIBUSB_TRANSFER_COMPLETED: int
LIBUSB_TRANSFER_ERROR: int
LIBUSB_TRANSFER_TIMED_OUT: int
LIBUSB_TRANSFER_CANCELLED: int
LIBUSB_TRANSFER_STALL: int
LIBUSB_TRANSFER_NO_DEVICE: int
LIBUSB_TRANSFER_OVERFLOW: int

class _libusb_endpoint_descriptor(Structure): ...
class _libusb_interface_descriptor(Structure): ...
class _libusb_interface(Structure): ...
class _libusb_config_descriptor(Structure): ...
class _libusb_device_descriptor(Structure): ...
class _libusb_iso_packet_descriptor(Structure): ...
class _libusb_transfer(Structure): ...

class _Device(_objfinalizer.AutoFinalizedObject):
    devid: Incomplete
    def __init__(self, devid) -> None: ...

class _WrapDescriptor:
    obj: Incomplete
    desc: Incomplete
    def __init__(self, desc, obj: Incomplete | None = ...) -> None: ...
    def __getattr__(self, name): ...

class _ConfigDescriptor(_objfinalizer.AutoFinalizedObject):
    desc: Incomplete
    def __init__(self, desc) -> None: ...
    def __getattr__(self, name): ...

class _DevIterator(_objfinalizer.AutoFinalizedObject):
    dev_list: Incomplete
    num_devs: Incomplete
    def __init__(self, ctx) -> None: ...
    def __iter__(self): ...

class _DeviceHandle:
    handle: Incomplete
    devid: Incomplete
    def __init__(self, dev) -> None: ...

class _IsoTransferHandler(_objfinalizer.AutoFinalizedObject):
    transfer: Incomplete
    def __init__(self, dev_handle, ep, buff, timeout) -> None: ...
    def submit(self, ctx: Incomplete | None = ...): ...

class _LibUSB(usb.backend.IBackend):
    lib: Incomplete
    ctx: Incomplete
    def __init__(self, lib) -> None: ...
    def enumerate_devices(self): ...
    def get_parent(self, dev): ...
    def get_device_descriptor(self, dev): ...
    def get_configuration_descriptor(self, dev, config): ...
    def get_interface_descriptor(self, dev, intf, alt, config): ...
    def get_endpoint_descriptor(self, dev, ep, intf, alt, config): ...
    def open_device(self, dev): ...
    def close_device(self, dev_handle) -> None: ...
    def set_configuration(self, dev_handle, config_value) -> None: ...
    def get_configuration(self, dev_handle): ...
    def set_interface_altsetting(self, dev_handle, intf, altsetting) -> None: ...
    def claim_interface(self, dev_handle, intf) -> None: ...
    def release_interface(self, dev_handle, intf) -> None: ...
    def bulk_write(self, dev_handle, ep, intf, data, timeout): ...
    def bulk_read(self, dev_handle, ep, intf, buff, timeout): ...
    def intr_write(self, dev_handle, ep, intf, data, timeout): ...
    def intr_read(self, dev_handle, ep, intf, buff, timeout): ...
    def iso_write(self, dev_handle, ep, intf, data, timeout): ...
    def iso_read(self, dev_handle, ep, intf, buff, timeout): ...
    def ctrl_transfer(
        self, dev_handle, bmRequestType, bRequest, wValue, wIndex, data, timeout
    ): ...
    def clear_halt(self, dev_handle, ep) -> None: ...
    def reset_device(self, dev_handle) -> None: ...
    def is_kernel_driver_active(self, dev_handle, intf): ...
    def detach_kernel_driver(self, dev_handle, intf) -> None: ...
    def attach_kernel_driver(self, dev_handle, intf) -> None: ...

def get_backend(find_library: Incomplete | None = ...): ...
